apiVersion: "networking.k8s.io/v1"
kind: "Ingress"
metadata:
  name: {{ include "runner.fullname" . }}
  labels: {{- include "runner.labels" . | nindent 4 }}
  annotations:
    traefik.ingress.kubernetes.io/router.middlewares:
      {{ .Release.Namespace }}-{{ include "runner.fullname" . }}-strip-prefix@kubernetescrd
    {{- if .Values.tls.enabled }}
      ,{{ .Release.Namespace }}-{{ include "runner.fullname" . }}-https-redirect@kubernetescrd
    cert-manager.io/cluster-issuer: "letsencrypt-{{ .Values.environment }}"
    {{- end }}
spec:
  ingressClassName: "traefik"
  rules:
    - http:
        paths:
          - backend:
              service:
                name: {{ include "runner.fullname" . }}
                port:
                  name: "api"
            path: '/{{ .Values.baseApiUrl }}'
            pathType: "Prefix"
          - backend:
              service:
                name: {{ include "runner.fullname" . }}
                port:
                  name: "api"
            path: '/api/{{ .Values.baseApiUrl }}'
            pathType: "Prefix"
          - backend:
              service:
                name: {{ include "runner.fullname" . }}
                port:
                  name: "user-api"
            path: '/user-api'
            pathType: "Prefix"
  {{- if .Values.tls.enabled }}
  tls:
    - hosts:
        - {{ .Values.tls.hostname }}
      secretName: {{.Values.tls.certSecret }}
  {{- end }}
---
apiVersion: traefik.containo.us/v1alpha1
kind: Middleware
metadata:
  name: {{ include "runner.fullname" . }}-strip-prefix
spec:
  stripPrefix:
    prefixes:
      - '/{{ .Values.baseApiUrl }}'
      - '/api/{{ .Values.baseApiUrl }}'
      - '/user-api'
{{- if .Values.tls.enabled }}
---
apiVersion: traefik.containo.us/v1alpha1
kind: Middleware
metadata:
  name: {{ include "runner.fullname" . }}-https-redirect
spec:
  redirectScheme:
    scheme: https
    permanent: true
{{- end }}
